import { Controller, useFormContext } from 'react-hook-form';

import { Field, TimeOfDayPicker } from '@grafana/ui';
import { t } from 'app/core/internationalization';
import { ReportBaseV2 } from 'app/extensions/types';

export function StartTimeInput() {
  const { control } = useFormContext<ReportBaseV2>();

  return (
    <Field label={t('share-report.schedule.start-time', 'Start time')}>
      <Controller
        name="schedule.startTime"
        render={({ field: { ref, ...field } }) => {
          return <TimeOfDayPicker {...field} minuteStep={10} />;
        }}
        control={control}
      />
    </Field>
  );
}
