import { jsx, jsxs } from 'react/jsx-runtime';
import { css } from '@emotion/css';
import { useMemo, useState, useCallback } from 'react';
import 'classnames';
import '../../../Icon/Icon.mjs';
import '../../../Tooltip/Tooltip.mjs';
import '../../../Forms/Legacy/Input/Input.mjs';
import 'react-select';
import '../../../Forms/Legacy/Select/Select.mjs';
import '../../../Forms/Legacy/Switch/Switch.mjs';
import 'lodash';
import { t, Trans } from '../../../../utils/i18n.mjs';
import { Button } from '../../../Button/Button.mjs';
import '../../../IconButton/IconButton.mjs';
import '@grafana/data';
import { useTheme2, useStyles2 } from '../../../../themes/ThemeContext.mjs';
import 'micro-memoize';
import '@emotion/react';
import 'tinycolor2';
import '../../../../utils/skeleton.mjs';
import '../../../Button/ButtonGroup.mjs';
import '@floating-ui/react';
import '../../../Portal/Portal.mjs';
import '../../../Toggletip/Toggletip.mjs';
import 'react-custom-scrollbars-2';
import '../../../Tabs/Tab.mjs';
import '../../../Tabs/TabsBar.mjs';
import '../../../Layout/Box/Box.mjs';
import '../../../ScrollContainer/ScrollContainer.mjs';
import '../../../Cascader/Cascader.mjs';
import '../../../Alert/Alert.mjs';
import 'rc-cascader';
import '../../../Cascader/styles.mjs';
import 'react-inlinesvg';
import '../../../../utils/keyframes.mjs';
import '../../../ColorPicker/ColorPicker.mjs';
import '../../../ColorPicker/ColorPickerInput.mjs';
import '../../../ColorPicker/SeriesColorPickerPopover.mjs';
import { Stack } from '../../../Layout/Stack/Stack.mjs';
import '../../../Text/Text.mjs';
import '../../../StatsPicker/StatsPicker.mjs';
import '../../../RefreshPicker/RefreshPicker.mjs';
import '../../../DateTimePickers/TimeRangePicker.mjs';
import '../../../DateTimePickers/TimeRangeContext.mjs';
import '../../../DateTimePickers/TimeRangePicker/TimeRangeLabel.mjs';
import 'rc-picker';
import 'rc-picker/lib/generate/moment';
import 'rc-picker/lib/locale/en_US';
import 'rc-picker/assets/index.css';
import 'react-select/async';
import 'react-select/async-creatable';
import 'react-select/creatable';
import '../../../Select/IndicatorsContainer.mjs';
import '../../../Select/InputControl.mjs';
import '../../../Select/getSelectStyles.mjs';
import '../../../Input/Input.mjs';
import '../../../Select/SelectMenu.mjs';
import 'react-transition-group';
import '../../../Select/ValueContainer.mjs';
import '@grafana/e2e-selectors';
import '@tanstack/react-virtual';
import 'downshift';
import '../../../Input/AutoSizeInput.mjs';
import '../../../Forms/Checkbox.mjs';
import '../../../Combobox/filter.mjs';
import '../../../../utils/dom.mjs';
import '../../../../utils/colors.mjs';
import 'slate';
import '../../../../utils/logger.mjs';
import '../../../DateTimePickers/DatePicker/DatePicker.mjs';
import '../../../DateTimePickers/DateTimePicker/DateTimePicker.mjs';
import '../../../List/AbstractList.mjs';
import 'react-table';
import '../../../InteractiveTable/Expander/index.mjs';
import '../../../TagsInput/TagsInput.mjs';
import '../../../Forms/Field.mjs';
import '../../../AutoSaveField/EllipsisAnimated.mjs';
import '../../../Tags/Tag.mjs';
import '../../../Tags/TagList.mjs';
import '../../../Modal/Modal.mjs';
import 'react-hook-form';
import '../../../QueryField/QueryField.mjs';
import '../../../Monaco/CodeEditor.mjs';
import 'react-use';
import '../../../ErrorBoundary/ErrorWithStack.mjs';
import '../../../Modal/ModalsContext.mjs';
import '../../../PageLayout/PageToolbar.mjs';
import 'rxjs';
import 'rxjs/operators';
import '../../TableRT/Table.mjs';
import '@react-aria/dialog';
import '@react-aria/focus';
import '@react-aria/overlays';
import 'rc-drawer';
import 'rc-drawer/assets/index.css';
import '../../../TableInputCSV/TableInputCSV.mjs';
import '../../../Tabs/VerticalTab.mjs';
import '../../../BigValue/BigValue.mjs';
import '../../../Sparkline/Sparkline.mjs';
import '../../../Gauge/Gauge.mjs';
import '../../../BarGauge/BarGauge.mjs';
import '../../../VizTooltip/VizTooltip.mjs';
import '../../../VizTooltip/VizTooltipContainer.mjs';
import '../../../VizLegend/SeriesIcon.mjs';
import '../../../VizRepeater/VizRepeater.mjs';
import '../../../PanelChrome/LoadingIndicator.mjs';
import '../../../ElementSelectionContext/ElementSelectionContext.mjs';
import '../../../Dropdown/Dropdown.mjs';
import '../../../ToolbarButton/ToolbarButton.mjs';
import '../../../ToolbarButton/ToolbarButtonRow.mjs';
import '../../../PanelChrome/TitleItem.mjs';
import '../../../PanelChrome/PanelContext.mjs';
import '../../../VizLayout/VizLayout.mjs';
import '../../../VizLegend/VizLegend.mjs';
import '../../../VizLegend/VizLegendListItem.mjs';
import { ClickOutsideWrapper } from '../../../ClickOutsideWrapper/ClickOutsideWrapper.mjs';
import '@grafana/schema';
import '../../../ContextMenu/ContextMenu.mjs';
import '../../../Menu/Menu.mjs';
import '../../../Menu/MenuGroup.mjs';
import '../../../Menu/MenuItem.mjs';
import '../../../DataLinks/DataLinkEditor.mjs';
import '@hello-pangea/dnd';
import '../../../Badge/Badge.mjs';
import '../../../DataLinks/DataLinkInput.mjs';
import '../../../InfoBox/InfoBox.mjs';
import '../../../InfoBox/FeatureInfoBox.mjs';
import '../../../JSONFormatter/JSONFormatter.mjs';
import '../../../ErrorBoundary/ErrorBoundary.mjs';
import '../../../Forms/InlineField.mjs';
import '../../../Forms/RadioButtonGroup/RadioButton.mjs';
import '../../../Switch/Switch.mjs';
import '../../../TextArea/TextArea.mjs';
import 'react-use/lib/useClickAway';
import 'rc-slider';
import 'rc-slider/assets/index.css';
import 'rc-tooltip';
import '../../../MatchersUI/fieldMatchersUI.mjs';
import '../../../Link/Link.mjs';
import '../../../Link/TextLink.mjs';
import '../../../Layout/Grid/Grid.mjs';
import { Label } from '../../../Forms/Label.mjs';
import '../../../Combobox/ValuePill.mjs';
import { FilterInput } from '../../../FilterInput/FilterInput.mjs';
import 'uuid';
import 'react-dropzone';
import '../../../DateTimePickers/TimeRangePicker/TimePickerContent.mjs';
import '../../../DateTimePickers/RelativeTimeRangePicker/RelativeTimeRangePicker.mjs';
import '../../../Card/Card.mjs';
import '../../../FormattedValueDisplay/FormattedValueDisplay.mjs';
import { ButtonSelect } from '../../../Dropdown/ButtonSelect.mjs';
import '../../../PluginSignatureBadge/PluginSignatureBadge.mjs';
import '../../../uPlot/config.mjs';
import 'uplot';
import '../../../uPlot/utils.mjs';
import 'uplot/dist/uPlot.min.css';
import '../../../uPlot/PlotLegend.mjs';
import 'react-dom';
import '../../../BrowserLabel/Label.mjs';
import '../../../../graveyard/Graph/Graph.mjs';
import '../../../../graveyard/GraphNG/GraphNG.mjs';
import '../../../../graveyard/TimeSeries/TimeSeries.mjs';
import '../../../../graveyard/GraphNG/hooks.mjs';
import { FilterList } from './FilterList.mjs';
import { calculateUniqueFieldValues, valuesToOptions, getFilteredOptions } from './utils.mjs';

const operatorSelectableValues = {
  Contains: { label: "Contains", value: "Contains", description: "Contains" },
  "=": { label: "=", value: "=", description: "Equals" },
  "!=": { label: "!=", value: "!=", description: "Not equals" },
  ">": { label: ">", value: ">", description: "Greater" },
  ">=": { label: ">=", value: ">=", description: "Greater or Equal" },
  "<": { label: "<", value: "<", description: "Less" },
  "<=": { label: "<=", value: "<=", description: "Less or Equal" },
  Expression: {
    label: "Expression",
    value: "Expression",
    description: 'Bool Expression (Char $ represents the column value in the expression, e.g. "$ >= 10 && $ <= 12")'
  }
};
const OPERATORS = Object.values(operatorSelectableValues);
const FilterPopup = ({
  name,
  rows,
  filterValue,
  setFilter,
  onClose,
  field,
  searchFilter,
  setSearchFilter,
  operator,
  setOperator
}) => {
  const theme = useTheme2();
  const uniqueValues = useMemo(() => calculateUniqueFieldValues(rows, field), [rows, field]);
  const options = useMemo(() => valuesToOptions(uniqueValues), [uniqueValues]);
  const filteredOptions = useMemo(() => getFilteredOptions(options, filterValue), [options, filterValue]);
  const [values, setValues] = useState(filteredOptions);
  const [matchCase, setMatchCase] = useState(false);
  const onCancel = useCallback((event) => onClose(), [onClose]);
  const onFilter = useCallback(
    (event) => {
      if (values.length !== 0) {
        const filteredSet = new Set(values.map((item) => item.value));
        setFilter((filter) => ({
          ...filter,
          [name]: { filtered: values, filteredSet, searchFilter, operator }
        }));
      } else {
        setFilter((filter) => {
          const newFilter = { ...filter };
          delete newFilter[name];
          return newFilter;
        });
      }
      onClose();
    },
    [setFilter, values, onClose]
    // eslint-disable-line react-hooks/exhaustive-deps
  );
  const onClearFilter = useCallback(
    (event) => {
      setFilter((filter) => {
        const newFilter = { ...filter };
        delete newFilter[name];
        return newFilter;
      });
      onClose();
    },
    [setFilter, onClose]
    // eslint-disable-line react-hooks/exhaustive-deps
  );
  const clearFilterVisible = useMemo(() => filterValue !== void 0, [filterValue]);
  const styles = useStyles2(getStyles);
  return /* @__PURE__ */ jsx(ClickOutsideWrapper, { onClick: onCancel, useCapture: true, children: /* @__PURE__ */ jsx("div", { className: styles.filterContainer, onClick: stopPropagation, children: /* @__PURE__ */ jsxs(Stack, { direction: "column", children: [
    /* @__PURE__ */ jsxs(Stack, { alignItems: "center", children: [
      field && /* @__PURE__ */ jsx(Label, { className: styles.label, children: field.config.displayName || field.name }),
      /* @__PURE__ */ jsx(
        ButtonSelect,
        {
          variant: "canvas",
          options: OPERATORS,
          onChange: setOperator,
          value: operator,
          tooltip: operator.description
        }
      )
    ] }),
    /* @__PURE__ */ jsx("div", { className: styles.listDivider }),
    /* @__PURE__ */ jsxs(Stack, { gap: 1, children: [
      /* @__PURE__ */ jsx(
        FilterInput,
        {
          placeholder: t("grafana-ui.table.filter-popup-input-placeholder", "Filter values"),
          onChange: setSearchFilter,
          value: searchFilter
        }
      ),
      /* @__PURE__ */ jsx(
        Button,
        {
          variant: "secondary",
          style: { color: matchCase ? theme.colors.text.link : theme.colors.text.disabled },
          onClick: () => {
            setMatchCase((s) => !s);
          },
          icon: "text-fields"
        }
      )
    ] }),
    /* @__PURE__ */ jsx(
      FilterList,
      {
        onChange: setValues,
        values,
        options,
        caseSensitive: matchCase,
        searchFilter,
        operator
      }
    ),
    /* @__PURE__ */ jsxs(Stack, { gap: 3, children: [
      /* @__PURE__ */ jsxs(Stack, { children: [
        /* @__PURE__ */ jsx(Button, { size: "sm", onClick: onFilter, children: /* @__PURE__ */ jsx(Trans, { i18nKey: "grafana-ui.table.filter-popup-apply", children: "Ok" }) }),
        /* @__PURE__ */ jsx(Button, { size: "sm", variant: "secondary", onClick: onCancel, children: /* @__PURE__ */ jsx(Trans, { i18nKey: "grafana-ui.table.filter-popup-cancel", children: "Cancel" }) })
      ] }),
      clearFilterVisible && /* @__PURE__ */ jsx(Stack, { children: /* @__PURE__ */ jsx(Button, { fill: "text", size: "sm", onClick: onClearFilter, children: /* @__PURE__ */ jsx(Trans, { i18nKey: "grafana-ui.table.filter-popup-clear", children: "Clear filter" }) }) })
    ] })
  ] }) }) });
};
const getStyles = (theme) => ({
  filterContainer: css({
    label: "filterContainer",
    width: "100%",
    minWidth: "250px",
    height: "100%",
    backgroundColor: theme.colors.background.primary,
    border: `1px solid ${theme.colors.border.weak}`,
    padding: theme.spacing(2),
    boxShadow: theme.shadows.z3,
    borderRadius: theme.shape.radius.default
  }),
  listDivider: css({
    label: "listDivider",
    width: "100%",
    borderTop: `1px solid ${theme.colors.border.medium}`
  }),
  label: css({
    marginBottom: 0
  })
});
const stopPropagation = (event) => {
  event.stopPropagation();
};

export { FilterPopup, operatorSelectableValues };
//# sourceMappingURL=FilterPopup.mjs.map
